Permutations - Leetcode 46 - Recursive Backtracking (Python)

Поделиться
HTML-код
  • Опубликовано: 13 янв 2025

Комментарии • 55

  • @GregHogg
    @GregHogg  5 месяцев назад +1

    Master Data Structures & Algorithms For FREE at AlgoMap.io!

  • @shreehari2589
    @shreehari2589 8 месяцев назад +22

    Greg you have natural talent in teaching, kindly don’t stop making videos

    • @GregHogg
      @GregHogg  8 месяцев назад +4

      Awe that's so sweet. Probably just practice as I've been learning and teaching for awhile now. I really appreciate it!! 😊

  • @jonTheDon28
    @jonTheDon28 20 дней назад +1

    After watching 3 different vids for this problem, this was the only solution where the code made intuitive sense to me, thanks for this fr

  • @DamosyTheFreckle
    @DamosyTheFreckle 3 месяца назад +1

    Dude I like your solutions because they are always so clean and the fact that you don't use "pythonic code" makes it so much more easier to understand. So many other people abuse python shortcuts that makes the code impossible to understand

  • @christianjt7018
    @christianjt7018 5 месяцев назад +4

    I learned backtracking thanks to you, thanks Greg!

    • @GregHogg
      @GregHogg  5 месяцев назад

      Amazing 😍😍

  • @AbhishekYadav-yw8kv
    @AbhishekYadav-yw8kv 4 месяца назад +2

    such an elegant explanation. Thanks Greg!

  • @dabian1916
    @dabian1916 5 месяцев назад +33

    so much better than neetcode

    • @GabriellBP1
      @GabriellBP1 5 месяцев назад +8

      have to agree on that one

    • @shubhamdas9489
      @shubhamdas9489 4 месяца назад +1

      Yeah

    • @Tallonest
      @Tallonest 4 месяца назад

      I agree, Greg’s are so well explained.. best channel on RUclips

    • @nandkarthik
      @nandkarthik 2 месяца назад +1

      Well, Neetcode solution works for both permutation I and permuation II problem though

    • @hariprasad_a-i4p
      @hariprasad_a-i4p 27 дней назад

      so true

  • @arthurpongsapak9756
    @arthurpongsapak9756 Месяц назад

    this solution is so much more understandable! thank you

  • @rathangpandit7504
    @rathangpandit7504 3 месяца назад

    Finally got a hang of backtracking because of you 🙏

  • @Techgether
    @Techgether 3 месяца назад +4

    should the checking of x in sol be counted inside the time complexity? if so, this will be O(n.n!)

    • @omarllama
      @omarllama 2 месяца назад +1

      Exactly, this is more like (n+1)! should have used a set() to track the parents. But since the maximum size in the problem description was 6, this makes it negligible.

    • @TheMadisonBluesBand
      @TheMadisonBluesBand Месяц назад +3

      Agreed. As @omarllama said, a set() should have been used.

  • @slater-cguy
    @slater-cguy 2 месяца назад

    This is a really intuitive solution, thank you!

  • @Steel16
    @Steel16 3 месяца назад +3

    Wouldn't the time complexity be O(n! * n) since we're checking each time if x is not in sol?

    • @DinhKhoaNguyen-h8d
      @DinhKhoaNguyen-h8d 2 месяца назад

      guess what, n! * n is n!

    • @Steel16
      @Steel16 2 месяца назад

      @@DinhKhoaNguyen-h8d It's not. If it was O(n + n!) then it would be O(n!) but O(n*n!) cannot be reduced because the growth rate is faster than O(n!) and is in a larger complexity class

  • @saurabh-11a
    @saurabh-11a 5 месяцев назад +2

    Hi Greg, I could not understand how the pop is working here, once we have the first solution, I dont understand how pop is happening twice in the for loop.

    • @stanleyching123
      @stanleyching123 5 месяцев назад +2

      Leaving a comment here as I want to also know

    • @SBManukrishna-jz6ud
      @SBManukrishna-jz6ud 4 месяца назад +4

      Hello Saurabh,
      Here is how pop() does the work here.After we append the first solution to ans,the control gets back to the "sol.pop()"line and we pop 3 from sol since its the last element. At this stage note that we are in the last iteration of for loop as well since x =3. So we don't have to execute anything further with backtrack() when x=3. So now we return back the sol which is [1,2] to backtrack() when x =2. Now the next line is sol.pop().So we pop 2 from sol and hence sol becomes [1].but here is the catch... now x=2 and the loop has 1 more interation for x=3 so we check if 3 is in solution and add it into sol and sol becomes [1,3], now we call backtrack() and we compare the len of sol to n which is not equal to 3 so we start the for loop afresh once again and check if 1 is in sol. Yes 1 is in sol=[1,3],but in next iteration when x=2 since 2 is not in sol, we add it to sol and add it to ans. This is how we formulate the 2nd solution. Hope you can figure out the flow for remaining solutions and hope this helped😊

    • @snehasrinivasan8666
      @snehasrinivasan8666 2 месяца назад

      ​@@SBManukrishna-jz6udGreat explanation, thank you!😁

  • @jz77096
    @jz77096 4 месяца назад

    I think this problem is purely a test of how to code it concisely.
    Leetcoding to land a Meta/Google position.
    Gotta use code that interviewers can read... so found 3 solutions:
    Dupes
    Insertion into a growing temp linkedList
    Rotations
    Took me a couple hours to solve on my own, giving up, then looking it up.

  • @spec6459
    @spec6459 2 месяца назад

    been coding for 1-2 months and im getting into these, my brain hurts

  • @HemanthKumar-vl9oh
    @HemanthKumar-vl9oh 6 месяцев назад

    Woow ! You made look so simple . Good job. Keep doing such videos

    • @GregHogg
      @GregHogg  6 месяцев назад

      Thank you!

  • @Zippo_1234
    @Zippo_1234 4 месяца назад +1

    This was excellent. Thank you

  • @dennybjustin
    @dennybjustin 3 месяца назад +1

    Thank you for the detailed explanation! Really appreciate your work. Recently, a company asked the Question Leetcode 1307 (cryptarithm) on my campus. Would you please consider providing a video solution for this question, in python?

  • @arunselvannatesan7494
    @arunselvannatesan7494 2 месяца назад

    Wouldn't the space complexity be exponential if we consider the recursion stack?

  • @ArdianUmam
    @ArdianUmam 3 месяца назад

    Great explanation, thanks!

  • @mehraan8592
    @mehraan8592 3 месяца назад

    very good explanation. thanks

  • @anisbhsl
    @anisbhsl 3 месяца назад

    Great explanation.

  • @sabaokangan
    @sabaokangan 8 месяцев назад +1

    Beautiful teaching

    • @GregHogg
      @GregHogg  8 месяцев назад

      Thanks a ton!!!

  • @saleheen12
    @saleheen12 2 месяца назад

    My brain hurts.
    Kind of understood it after watching many times

  • @rishabkalluri662
    @rishabkalluri662 6 месяцев назад

    Isn't the time complexity N! * n? , checking if x in sol is n

    • @rishabkalluri662
      @rishabkalluri662 6 месяцев назад

      or copying solution before you add it is n

  • @GarouNguyen
    @GarouNguyen 6 месяцев назад

    bro what is if x not in sol, can you explain that I don't understand bro

    • @GregHogg
      @GregHogg  6 месяцев назад

      If we've already used the number, we don't want to use it again

  • @aswination
    @aswination 8 месяцев назад

    Excellent video!
    How would the code change if there are duplicate numbers in the array?

    • @GregHogg
      @GregHogg  8 месяцев назад

      Thank you! And there's actually a problem for that, might cover it at some point :)

  • @isako1234
    @isako1234 5 месяцев назад

    its O(n! * n), because of the line: if x not in sol

  • @saurabhbhagat4528
    @saurabhbhagat4528 4 месяца назад

    We can actually use a Set instead of an array for "sol", then it'd be faster to check if a number is already in the current solution

    • @Techgether
      @Techgether 3 месяца назад

      good idea but i tried and the order of set is not preserved after insertion, at least for python wise

    • @TheMadisonBluesBand
      @TheMadisonBluesBand Месяц назад

      @@Techgether yes that's why use array for sol and then set for visited. Then check if num is in visited, not sol

  • @SoraJustAGuy
    @SoraJustAGuy 3 месяца назад

    thanks mate

  • @vivek2319
    @vivek2319 4 месяца назад

    Thanks

  • @tauicsicsics
    @tauicsicsics Месяц назад

    explanations are great but the variable namings not so great. ans and sol? both mean the same thing, it's unclear which is the final one. maybe currSubset or smth like this.

  • @vroomerlifts
    @vroomerlifts 6 месяцев назад

    hell yeah